﻿package 
{
	import flash.display.DisplayObject;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoaderDataFormat;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	/**
	 * ...
	 * @author yves trublin
	 */
	public class FichierXML
	{
		private var context:DisplayObject;
		private var xml:XML;
		
		public function FichierXML(ct:DisplayObject, url:String, variables:URLVariables) 
		{
			context = ct;
			
			// URLRequest
			var request:URLRequest = new URLRequest();
			request.method = URLRequestMethod.GET;	
			request.data = variables;
			request.url =  url;
			
			// URLLoader
			var xmlLoader:URLLoader = new URLLoader(request);
			xmlLoader.dataFormat = URLLoaderDataFormat.TEXT;
			
			// ecouteurs
			xmlLoader.addEventListener(IOErrorEvent.IO_ERROR, handleXMLIOError, false, 0, true);
			xmlLoader.addEventListener(Event.COMPLETE, handleXMLComplete, false, 0, true);
			
			// lecture fichier XML
			xmlLoader.load(request);
		}
		
		private function handleXMLComplete(e:Event):void 
		{
			e.currentTarget.removeEventListener(IOErrorEvent.IO_ERROR, handleXMLIOError);
			e.currentTarget.removeEventListener(Event.COMPLETE, handleXMLComplete);
			
			// on assigne le resultat de la lecture du fichier XML
			xml = new XML(e.currentTarget.data);

			// on propage l'evenement
			context.dispatchEvent(new Event(Event.COMPLETE));
		}
		
		private function handleXMLIOError(e:Event):void 
		{
			e.currentTarget.removeEventListener(IOErrorEvent.IO_ERROR, handleXMLIOError);
			e.currentTarget.removeEventListener(Event.COMPLETE, handleXMLComplete);
		}
		
		//////////////////////////////////////////////////////////
		// getter / setter methods
		//////////////////////////////////////////////////////////
		public function get xmlData():XML {
			return xml;
		}
	}

}