﻿package  
{
	import com.flashdynamix.motion.TweensyZeroMinified;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	/**
	 * ...
	 * @author yves trublin
	 */
	public class Loading extends Sprite
	{
		private var texte:TextField;
		private var fond:Shape;
		private var nbPhotos:int;
		private var texteChargement:String;
		private var couleurFondChargement:uint;
		private var alphaFondChargement:Number;
		
		public function Loading()
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			nbPhotos = root["xml"].Photo.length();
			texteChargement = root["xml"].@["texteChargement"];
			couleurFondChargement = root["xml"].@["couleurFondChargement"]
			alphaFondChargement = root["xml"].@["alphaFondChargement"]
			
			// fond
			fond = new Shape();
			addChild(fond);
			
			// textFormat
			var tf:TextFormat = new TextFormat();
			tf.font = root["xml"].@["police"];
			tf.size = root["xml"].@["tailleTexte"];
			tf.color = root["xml"].@["couleurTexteChargement"];
			tf.align = TextFormatAlign.LEFT;
			
			// texte
			texte = new TextField();
			texte.autoSize = TextFieldAutoSize.LEFT;
			texte.defaultTextFormat = tf;
			texte.selectable = false;
			addChild(texte);
			
			miseAJourTexte(1);
		}
		
		public function miseAJourTexte(c:int):void
		{
			texte.text = texteChargement + " " + c + " / " + nbPhotos;
			fond.graphics.clear();
			fond.graphics.beginFill(couleurFondChargement, alphaFondChargement);
			fond.graphics.drawRect(0, 2, texte.textWidth + 4, texte.textHeight);
			fond.graphics.endFill();
		}
		
		public function cacherLoading():void {
			TweensyZeroMinified.to(this.transform.colorTransform, { alphaMultiplier:0 }, .5, null, this, detruireLoading);
		}
		
		private function detruireLoading():void
		{
			removeChild(texte);
			parent.removeChild(this);
		}
	}
}