﻿package 
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.net.URLVariables;
	import com.flashdynamix.motion.TweensyZeroMinified;
	
	/**
	 * ...
	 * @author yves trublin
	 */
	public class Main extends Sprite 
	{
		//////////////////////////////////////////////
		// Variables generales
		//////////////////////////////////////////////
		public var xml:XML;
		public var photoCour:int;
		
		private var stageWidth:Number;
		private var stageHeight:Number;
		private var hauteurZonePhotos:Number;
		private var vitesseOuvertureZoneMiniature:Number;
		
		//////////////////////////////////////////////
		// assets
		//////////////////////////////////////////////
		private var fichierXml:FichierXML;
		private var photoLoader:PhotoLoader;
		private var prec:Bouton;
		private var suiv:Bouton;
		private var containerPhotos:Sprite;
		private var zoneMiniatures:ZoneMiniatures;
		private var lecteur:Lecteur;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		////////////////////////////////////////////////////////////////////////////
		// Added to stage, initialisation
		////////////////////////////////////////////////////////////////////////////
		private function init(e:Event = null):void 
		{
			if(hasEventListener(Event.ADDED_TO_STAGE)){
				removeEventListener(Event.ADDED_TO_STAGE, init);
			}
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			stage.quality = StageQuality.BEST;

			///////////////////////////////////////////////////////////////////////
			//
			//
			///////////////////////////////////////////////////////////////////////
			//recuperation des parametres
			var variables:URLVariables = new URLVariables();
			var url:String;
			for (var i:Object in loaderInfo.parameters) {
				if (i == "url") {
					url = loaderInfo.parameters[i];
				}else{
					variables[i] = loaderInfo.parameters[i];
				}
			}

			// telechargement fichier XML
			fichierXml = new FichierXML(this, url, variables);
			///////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////
			
			photoCour = 0;
			
			// ecouteur sur fin telechargement XML
			this.addEventListener(Event.COMPLETE, handleXMLComplete, false, 0, true);
		}

		////////////////////////////////////////////////////////////////////////////
		// XML Complete
		////////////////////////////////////////////////////////////////////////////
		private function handleXMLComplete(e:Event):void 
		{
			this.removeEventListener(Event.COMPLETE, handleXMLComplete);

			// affectiation des donnees du XML
			xml = fichierXml.xmlData;
			
			// taille du stage
			stageWidth = stage.stageWidth;
			stageHeight = stage.stageHeight;
			hauteurZonePhotos = stageHeight - xml.@["hauteurZoneOver"];
			
			// fond
			var fond:Shape = new Shape();
			fond.graphics.beginFill(xml.@["couleurFond"]);
			fond.graphics.drawRect(0, 0, stageWidth, stageHeight);
			fond.graphics.endFill();
			addChild(fond);
			
			if (xml.Photo.length() != 0) {
				initLoading();
			}else {
				removeSWF();
			}
		}
		
		private function removeSWF():void
		{
			try {
				ExternalInterface.call('function(){swfobject.removeSWF("flash_diaporama");}');
			} catch (e:Error) {
				//error
			}
		}
		
		private function initLoading():void
		{
			// photoLoader
			photoLoader = new PhotoLoader(stageWidth, hauteurZonePhotos);
			addChild(photoLoader);
			
			// lecteur
			lecteur = new Lecteur(xml.Photo.length());
			lecteur.x = stageWidth;
			lecteur.y = xml.@["hauteurTraitChargement"];
			addChild(lecteur);

			// vitesse affichage photo
			vitesseOuvertureZoneMiniature = xml.@["vitesseOuvertureZoneMiniature"];
			
			// ajout listener sur photo courante telechargee et toutes photos telechragees
			addEventListener("photo_chargee", handlePhotoChargee, false, 0, true);			
		}
		
		////////////////////////////////////////////////////////////////////////////
		// Gestion chargement des photos
		////////////////////////////////////////////////////////////////////////////
		private function handlePhotoChargee(e:Event):void 
		{
			var nbPhotoDispo:int = photoLoader.nombrePhotosDispo;
			lecteur.nombrePhotosDispo = nbPhotoDispo;
			
			// actions si premiere photo chargee :
			if (nbPhotoDispo == 1) {
				// on ajoute et on initialise la zone des miniature
				zoneMiniatures = new ZoneMiniatures(stageWidth, stageHeight);
				addChildAt(zoneMiniatures, numChildren - 2);
				
				// on ajoute le containner des photos
				containerPhotos = new Sprite();
				containerPhotos.x = stageWidth * .5;
				addChildAt(containerPhotos, numChildren - 2);

				// menu contextuel
				var menuContextuel:MenuContextuel = new MenuContextuel();
				containerPhotos.addChild(menuContextuel);
			
				// on affiche la premiere photo dans le container des photos
				var photo:Photo = new Photo(photoLoader.getBitmapData(0), hauteurZonePhotos);
				containerPhotos.addChild(photo);
				photo.montrerPhoto();
				
				// on ajoute la miniature a zoneMiniatures et on l'active
				zoneMiniatures.ajouterMiniature(photoLoader.getBitmapData(nbPhotoDispo - 1));				
				zoneMiniatures.activerMiniature(0);
				
				// ajout ecouteur OVER / OUT sur zoneMiniatures
				zoneMiniatures.addEventListener(MouseEvent.ROLL_OVER, handleZoneMiniatureOverOut, false, 0, true);
				zoneMiniatures.addEventListener(MouseEvent.ROLL_OUT, handleZoneMiniatureOverOut, false, 0, true);
									
			// actions si deuxieme photo chargee :
			}else if (nbPhotoDispo == 2) {
				// on ajoute les boutons prec et suiv
				prec = new Bouton(hauteurZonePhotos);
				addChildAt(prec, numChildren - 2);
				suiv = new Bouton(hauteurZonePhotos);
				suiv.scaleX = -1;
				suiv.x = stageWidth;
				addChildAt(suiv, numChildren - 2);
				
				// ajout ecouteurs CLICK sur prec et suiv
				prec.addEventListener(MouseEvent.CLICK, handlePrecSuivClick, false, 0, true);
				suiv.addEventListener(MouseEvent.CLICK, handlePrecSuivClick, false, 0, true);

				// on ajoute la miniature a zoneMiniatures
				zoneMiniatures.ajouterMiniature(photoLoader.getBitmapData(nbPhotoDispo - 1));
				
			// actions si toutes photos chargees :
			}else if (nbPhotoDispo == xml.Photo.length()) {
				// on supprime l'ecouteur sur les photos chargees
				removeEventListener("photo_chargee", handlePhotoChargee);
				
				// on ajoute la miniature a zoneMiniatures
				zoneMiniatures.ajouterMiniature(photoLoader.getBitmapData(nbPhotoDispo - 1));
				
			// actions par defaut :
			}else {
				// on ajoute la miniature a zoneMiniatures
				zoneMiniatures.ajouterMiniature(photoLoader.getBitmapData(nbPhotoDispo - 1));
			}
			
			// on tween la zone des miniatures si la souris est dessus
			if(zoneMiniatures.hitTestPoint(mouseX, mouseY)){
				handleZoneMiniatureOverOut(new MouseEvent(MouseEvent.ROLL_OVER));
			}
		}

		////////////////////////////////////////////////////////////////////////////
		// Gestion RollOver / rollOut sur zoneMiniatures
		////////////////////////////////////////////////////////////////////////////
		private function handleZoneMiniatureOverOut(e:MouseEvent):void 
		{
			var rapport:Number = 1;
			if (e.type == MouseEvent.ROLL_OVER) {
				rapport = (stageHeight - zoneMiniatures.height) / hauteurZonePhotos;
				zoneMiniatures.montrerZoneMiniature();
			}else {
				zoneMiniatures.cacherZoneMiniature();
			}
			TweensyZeroMinified.to(containerPhotos.transform.matrix, { a:rapport, d:rapport }, vitesseOuvertureZoneMiniature, null, containerPhotos );
			if (prec) {
				prec.racourcirBouton(rapport);
				suiv.racourcirBouton(rapport);
			}
		}
		
		////////////////////////////////////////////////////////////////////////////
		// Gestion clic bouton prec et suiv
		////////////////////////////////////////////////////////////////////////////
		private function handlePrecSuivClick(e:MouseEvent):void 
		{
			var npd:int = photoLoader.nombrePhotosDispo;
			photoCour = (e.currentTarget == suiv) ? (photoCour + 1) % npd : (photoCour - 1 + npd) % npd;
			montrerPhotoCourante();
		}

		////////////////////////////////////////////////////////////////////////////
		// Fonction de gestion d'affichage des photos courante et precedente
		////////////////////////////////////////////////////////////////////////////
		public function montrerPhotoCourante():void
		{
			// photo precedente
			var photoP:Photo = containerPhotos.getChildAt(containerPhotos.numChildren - 1) as Photo;
			
			// photo courante
			var photoC:Photo = new Photo(photoLoader.getBitmapData(photoCour), hauteurZonePhotos);
			containerPhotos.addChild(photoC);
			
			photoP.cacherPhoto();
			photoC.montrerPhoto();
		
			// affiche le titre et la description de la photo courante
			zoneMiniatures.description.afficherDescription(photoCour);
			
			// active la miniature correspondant a la photo courante
			zoneMiniatures.activerMiniature(photoCour);
		}
	}
}