﻿package  
{
	import com.flashdynamix.motion.TweensyZeroMinified;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;
	/**
	 * ...
	 * @author yves trublin
	 */
	public class ZoneMiniatures extends Sprite
	{
		public var description:Description;

		private var tailleMiniature:Number;
		private var hauteurZoneOver:Number;
		private var stageWidth:Number;
		private var stageHeight:Number;
		private var nombreColonnesMax:int;
		private var containerMiniatures:Sprite;

		private var colonneCourante:int = 0;
		private var ligneCourante:int = 0;
		private var miniatureActive:int = 0;
		private var vitesseOuvertureZoneMiniature:Number;

		public function ZoneMiniatures(sw:Number, sh:Number)
		{
			stageWidth = sw;
			stageHeight = sh;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			tailleMiniature = root["xml"].@["tailleMiniature"];
			var nombreLignesMiniature:int = root["xml"].@["nombreLignesMiniature"];
			hauteurZoneOver = root["xml"].@["hauteurZoneOver"];
			vitesseOuvertureZoneMiniature = root["xml"].@["vitesseOuvertureZoneMiniature"];
			var nbPhotos:int = root["xml"].Photo.length();
			
			// on verifie que le nombre de lignes de miniature a afficher n'excede pas la hauteur du stage
			if (tailleMiniature * nombreLignesMiniature + hauteurZoneOver > stageHeight) {
				nombreLignesMiniature = Math.floor((stageHeight - hauteurZoneOver) / tailleMiniature);
			}
			
			// calcul du nombre de colonnes max par page
			var nombreColonnesMaxPage:int = Math.floor(stageWidth / tailleMiniature);
			nombreColonnesMax = nombreColonnesMaxPage * Math.ceil(nbPhotos / (nombreColonnesMaxPage * nombreLignesMiniature));
			
			// si adapterColonne est a true
			if (root["xml"].@["adapterColonne"] == "true") {
				//tailleMiniature = Math.floor(stageWidth / nombreColonnesMaxPage);
				tailleMiniature = stageWidth / nombreColonnesMaxPage;
				// calcul du nombre de colonnes max par page
				nombreColonnesMaxPage = Math.floor(stageWidth / tailleMiniature);
				nombreColonnesMax = nombreColonnesMaxPage * Math.ceil(nbPhotos / (nombreColonnesMaxPage * nombreLignesMiniature));
			}
			
			containerMiniatures = new Sprite();
			containerMiniatures.y = hauteurZoneOver;
			addChild(containerMiniatures);
			y = stageHeight - hauteurZoneOver;
			description = new Description();
			addChild(description);
			
			dessineFond();
			
			// check de l'ouverture automatique
			if (root["xml"].@["zonesMiniaturesOuvertureAuto"] == "true") montrerZoneMiniature(true);
		}
		
		private function handleOverOut(e:MouseEvent):void 
		{
			if (e.type == MouseEvent.ROLL_OVER) {
				montrerZoneMiniature();
			}else {
				cacherZoneMiniature();
			}			
		}
		
		private function dessineFond():void {
			graphics.clear();
			graphics.beginFill(root["xml"].@["couleurFondZoneOver"], root["xml"].@["alphaFondZoneOver"]);
			graphics.lineStyle(root["xml"].@["epaisseurLignesZonesMiniatures"], root["xml"].@["couleurLignesZonesMiniatures"], root["xml"].@["alphaLignesZonesMiniatures"]);
			graphics.lineTo(stageWidth, 0);
			graphics.lineStyle();
			graphics.lineTo(stageWidth, hauteurZoneOver);
			graphics.lineStyle(root["xml"].@["epaisseurLignesZonesMiniatures"], root["xml"].@["couleurLignesZonesMiniatures"], root["xml"].@["alphaLignesZonesMiniatures"]);
			graphics.lineTo(0, hauteurZoneOver);
			graphics.lineStyle();
			graphics.lineTo(0, 0);
			graphics.endFill();
			graphics.moveTo(0, hauteurZoneOver);
			graphics.beginFill(root["xml"].@["couleurFondZoneMiniature"], root["xml"].@["alphaFondZoneMiniature"]);
			graphics.lineStyle(root["xml"].@["epaisseurLignesZonesMiniatures"], root["xml"].@["couleurLignesZonesMiniatures"], root["xml"].@["alphaLignesZonesMiniatures"]);
			graphics.lineTo(stageWidth, hauteurZoneOver);
			graphics.lineStyle();
			graphics.lineTo(stageWidth, hauteurZoneOver + containerMiniatures.height);
			graphics.lineStyle(root["xml"].@["epaisseurLignesZonesMiniatures"], root["xml"].@["couleurLignesZonesMiniatures"], root["xml"].@["alphaLignesZonesMiniatures"]);
			graphics.lineTo(0, hauteurZoneOver + containerMiniatures.height);
			graphics.lineStyle();
			graphics.lineTo(0, hauteurZoneOver);
			graphics.endFill();
		}
		
		public function montrerZoneMiniature(autoOpen:Boolean = false):void {
			var ty:Number = stageHeight - hauteurZoneOver - containerMiniatures.height;
			if (!autoOpen) {
				addEventListener(MouseEvent.MOUSE_MOVE, handleMouseMove, false, 0, true);
			}else {
				ty = stageHeight - hauteurZoneOver - tailleMiniature;
			}
			TweensyZeroMinified.to(this, { y: ty }, vitesseOuvertureZoneMiniature );
		}
		
		public function cacherZoneMiniature():void {
			TweensyZeroMinified.to(this, { y: stageHeight - hauteurZoneOver }, vitesseOuvertureZoneMiniature );
			if(hasEventListener(MouseEvent.MOUSE_MOVE))	removeEventListener(MouseEvent.MOUSE_MOVE, handleMouseMove);
		}
		
		public function ajouterMiniature(bmd:BitmapData):void
		{
			var miniature:Miniature = new Miniature(tailleMiniature, bmd);
			containerMiniatures.addChild(miniature);
			
			// ecouteur sur FOCUS_IN
			miniature.addEventListener(FocusEvent.FOCUS_IN, handleMiniFocusIn, false, 0, true);
			
			// replacement de la miniature
			miniature.x = tailleMiniature * colonneCourante;
			colonneCourante ++;
			miniature.y = tailleMiniature * ligneCourante;
			
			miniature.tabIndex = containerMiniatures.numChildren;
			
			// on met a jour les graphics de la zone
			dessineFond();
			
			if (colonneCourante > nombreColonnesMax - 1) {
				ligneCourante ++;
				colonneCourante = 0;
			}
		}
		
		private function handleMiniFocusIn(e:FocusEvent):void
		{
			var cmi:int = containerMiniatures.getChildIndex(e.currentTarget as DisplayObject);
			if (root["photoCour"] != cmi) {
				root["photoCour"] = cmi;
				root["montrerPhotoCourante"]();
				bougeContainerMiniature( - e.currentTarget.x + (stageWidth - tailleMiniature) * .5);
			}
		}

		private function handleMouseMove(e:MouseEvent):void 
		{
			bougeContainerMiniature(containerMiniatures.x + (stageWidth * .5 - mouseX));
		}
		private function bougeContainerMiniature(tx:Number):void
		{
			if (tx > 0) {
				tx = 0;
			}
			if (tx < - containerMiniatures.width + stageWidth) {
				tx = - containerMiniatures.width + stageWidth;
			}
			if(containerMiniatures.width > stageWidth){
				TweensyZeroMinified.to(containerMiniatures, { x: tx }, 1);
			}
			
		}
		
		// active la miniature courante
		public function activerMiniature(c:int):void
		{
			var miniPrec:Miniature = containerMiniatures.getChildAt(miniatureActive) as Miniature;
			miniPrec.desactiverMiniature();
			
			var miniActive:Miniature = containerMiniatures.getChildAt(c) as Miniature;
			miniActive.activerMiniature();
			
			miniatureActive = c;
		}
	}

}